#define Bit(n) (1 << (n))
/*
  p |= Bit(n);                   n   p:
  p &= ~Bit(n);                  n   p:
  if ((p & Bit(n)) != 0) ...     n   p: ()
*/
#define EEADR1 10                                                               //        ( EE,  ,
#define EEADR2 22                                                               //         ,  1)

#include <iom8.h>
#include <inavr.h>
#include <stdio.h>
#include <string.h>

static char seg[4],seg_count=0;                                                 //       4-    ;   
static char timer2comp=0,g_eesave_en=0;                                         //    ,   EE
static char str[10];
static unsigned short ADCrez=0,g_Hset=0;                                        //    ;  ( )
static char g_Uset=1,g_Hblk=3,g_Hled=0;                                         //   (User); "" n-   ();     
static unsigned short g_time_ovf=0;                                             //  ""  
static unsigned long g_fors_time=0,g_full_time=0,g_total_fuel=0;                // t()  ; t  .  . ;  t  . /1000 (.  1000), ..      -   
static unsigned short g_time_s=0,mg_fuel=0;                                     //  . ,     . ;

//-----------------------------------------------------------------------------------------------------------------------------
#pragma vector = INT1_vect                                                      // INT1 (
__interrupt void MY_INT1 (void)                                                 //  )
{
    if ((MCUCR & Bit(ISC10)) != 0)                                              //     
    {   TCCR1B = Bit(CS11);                                                     //   c clk/8
        MCUCR &= ~Bit(ISC10);                                                   //     MCUCR       
    }
    else                                                                        //    
    {   TCCR1B = 0;                                                             //  
        MCUCR |= Bit(ISC10);                                                    //     MCUCR       
        g_fors_time = g_time_ovf; g_fors_time = g_fors_time << 16; g_fors_time = g_fors_time + TCNT1;   //    , 16-. ,    8-. 
        g_full_time = g_full_time + g_fors_time;
        TCNT1 = 0; g_time_ovf=0;
    }
    
}
//-----------------------------------------------------------------------------------------------------------------------------
#pragma vector = TIMER1_OVF_vect                                                // timer 1 overflow -  
__interrupt void MY_TIMER1_OVF (void)                                           //              ,  ...  
{
g_time_ovf ++;                                                                  //  "" (   65536)    1

    if (g_time_ovf > 28)                                                        // 2    - 7372800/8/65536 = 14 () -  1 .()
    {TCCR1B = 0;                                                                //  
     MCUCR |= Bit(ISC10);                                                       //     MCUCR       
     TCNT1 = 0; g_time_ovf=0;
     g_eesave_en=1;                                                             //         EE
    }    
}
//-----------------------------------------------------------------------------------------------------------------------------
#pragma vector = ADC_vect                                                       // ADC - 10- 
__interrupt void MY_ADC (void)
{
ADCrez = ADCL; ADCrez = ADCrez + (ADCH << 8);                                   //   2-  10-  , (  (L),   (H)
}
//-----------------------------------------------------------------------------------------------------------------------------
#pragma vector = TIMER2_COMP_vect                                               // -            (  7200), ..  7200    1 (  20);
__interrupt void MY_TIMER2_COMPARE (void)                                       //       (  )  20,    20     (    
{                                                                               //     , .   main)
timer2comp=1;
}
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
void init ()                                                                    //  
{
char m=0;                                                                       //      EE
DDRD |= Bit(5);                                                                 //   
DDRD |= Bit(6);
DDRD |= Bit(7);
DDRB |= Bit(0);
DDRB |= Bit(1);
DDRB |= Bit(2);
DDRB |= Bit(3);
DDRB |= Bit(4);

DDRC |= Bit(3);
DDRC |= Bit(4);
DDRC |= Bit(5);
DDRD |= Bit(0);

DDRD |= Bit(4);
PORTD &= ~Bit(3);                                                               // INT1  (   )   ,   0 (   )

seg[0]=6; seg[1]=91; seg[2]=79; seg[3]=102;                                     //  ""    "4321"
//------------------------------------------------------------- timer counter 2
OCR2 = 20;                                                                      //  ""        ""  7372800/1024( . ) / 20 = 360, 360/4=90 -  ""   
TIMSK |= Bit(OCIE2);                                                            //       "" / 2
TCCR2 = Bit(WGM21) | Bit(CS22) | Bit(CS21) | Bit(CS20);                         //   ""      TCCR2 : CTC(  ),  -     1024
//------------------------------------------------------------- timer counter 1
TIMSK |= Bit(TOIE1);                                                            //       / 1
//----------------------------------------------------------------------- INT 1
MCUCR |= Bit(ISC11);                                                            //  ( const )      .    
MCUCR |= Bit(ISC10);                                                            //       .    
GICR |= Bit(INT1);                                                              //    INT1
//------------------------------------------------------------------------- ADC
ADMUX = Bit(REFS0);                                                             //     - 2.56 V
ADCSR = Bit(ADEN) | Bit(ADIE) | Bit(ADPS2) | Bit(ADPS1) | Bit(ADPS0);           //   ""      ADCSR :  ,  -       128
ADCSR |= Bit(ADSC);                                                             //        ( )      
//--------------------------------------------------------------------- read EE
__EEGET(g_Hset, EEADR1); g_Hset = g_Hset << 8; __EEGET(m, EEADR1+1); g_Hset = g_Hset + m;   //  1-  16- g_Hset   EEADR1        EEADR1+1
if (g_Hset > 9999) g_Hset = 0;                                                  //    "  "  F -

__EEGET(g_total_fuel, EEADR2); g_total_fuel = g_total_fuel << 8;                //  1-  32- g_total_fuel   EEADR2      .. ;   EEADR2       g_total_fuel,
__EEGET(m, EEADR2+1); g_total_fuel = g_total_fuel + m; g_total_fuel = g_total_fuel << 8;    //     8  ,     g_total_fuel  16 ,      EEADR2+1 
__EEGET(m, EEADR2+2); g_total_fuel = g_total_fuel + m; g_total_fuel = g_total_fuel << 8;    //    "m",     g_total_fuel  "m"    g_total_fuel       8
__EEGET(m, EEADR2+3); g_total_fuel = g_total_fuel + m;                          //     g_total_fuel  3- ,  ..  4-(32) (),   ,      g_total_fuel  EE;
                                                                                //    ,         ,      ""         
//-----------------------------------------------------------------------------
__enable_interrupt();                                                           //    (  SREG   7,  " I "
}
//-----------------------------------------------------------------------------------------------------------------------------
char OutDisp ()                                                                 //    " "
{
static char key=0;                                                              //      

    PORTD &= ~Bit(0);                                                           //      () 
    PORTC &= ~Bit(5);
    PORTC &= ~Bit(4);
    PORTC &= ~Bit(3);

  if ((seg[seg_count] & Bit(0)) != 0)   {PORTD &= ~Bit(6);} else {PORTD |= Bit(6);}   //     "" :      ; 
  if ((seg[seg_count] & Bit(1)) != 0)   {PORTD &= ~Bit(7);} else {PORTD |= Bit(7);}   // seg[0] = 11011000,    ""  "11111111"  ( 1)   ( 0)
  if ((seg[seg_count] & Bit(2)) != 0)   {PORTB &= ~Bit(0);} else {PORTB |= Bit(0);}   //    ;   ""       
  if ((seg[seg_count] & Bit(3)) != 0)   {PORTB &= ~Bit(1);} else {PORTB |= Bit(1);}   // 8-      "a b c d e f g h" : PD6-a(0-,  ), PD7-b, ..., PB4-g, PD5-h(7-, )
  if ((seg[seg_count] & Bit(4)) != 0)   {PORTB &= ~Bit(2);} else {PORTB |= Bit(2);}
  if ((seg[seg_count] & Bit(5)) != 0)   {PORTB &= ~Bit(3);} else {PORTB |= Bit(3);}
  if ((seg[seg_count] & Bit(6)) != 0)   {PORTB &= ~Bit(4);} else {PORTB |= Bit(4);}
  if ((seg[seg_count] & Bit(7)) != 0)   {PORTD &= ~Bit(5);} else {PORTD |= Bit(5);}

    if (seg_count == 0) {PORTD |= Bit(0);} else {PORTD &= ~Bit(0);}             //   
    if (seg_count == 1) {PORTC |= Bit(5);} else {PORTC &= ~Bit(5);}
    if (seg_count == 2) {PORTC |= Bit(4);} else {PORTC &= ~Bit(4);}
    if (seg_count == 3) {PORTC |= Bit(3);} else {PORTC &= ~Bit(3);}

  if ((PINC & Bit(2)) != 0) {key |= Bit(seg_count); } else {key &= ~Bit(seg_count);}   //   (" ):   n-,   key     n-, 
                                                                                //     : ( (0-) - 0001 (1),  - 0010 (2), 3- - 0100 (4), 4- - 1000 (8)
seg_count++;                                                                    //     
if (seg_count > 3) seg_count=0;                                                 //  
return key;                                                                     //   key       
}
//-----------------------------------------------------------------------------------------------------------------------------
char getCode (char ch)                                                          // ""    ASCII "" ,
{                                                                               //       
    switch (ch)                                                                 //    , :
    {   case '0': return  63; // "0"                                            // 63 - 0b00111111,   ""  - abcdef,      - 0
        case '1': return   6; // "1"                                            // 0b00000110 - bc
        case '2': return  91; // "2"                                            // 0b01011011 - ab de g
        case '3': return  79; // "3"
        case '4': return 102; // "4"
        case '5': return 109; // "5"
        case '6': return 125; // "6"
        case '7': return   7; // "7"
        case '8': return 127; // "8"
        case '9': return 111; // "9"
        case 'U': return  62; // 
        case 'H': return 118; // 
        case 'F': return 113; // 
        case ' ': return   0; // 
    }
return 1;                                                                       //  , "" (     "a"  )
}
//-----------------------------------------------------------------------------------------------------------------------------
void SetDataDisp (char mode, unsigned short parameter)                          //  16-    10-
{                                                                               //      ("")
char s;
    switch (mode)
    {   case 0:                                                                 //   - "4321"
                break;
        case 1:                                                                 // 
                sprintf (str,"U%3d",parameter);                                 //  "U"();  3   10- ; 16-   parameter   10-  ()        getCode
                s=getCode (str[0]); s=s|(1<<7); seg[3]=s;                       //   getCode   1- (.)  - "U";       7- ,     "h", ..   1- . ;       (), ..  1- .       OutDisp
                s=getCode (str[1]); seg[2]=s;                                   //   getCode   2- .  - 1-   3- (%3d)  ,    parameter,    (  ~ 5-18V)    - main ()
                s=getCode (str[2]); s=s|(1<<7); seg[1]=s;
                s=getCode (str[3]); seg[0]=s;
                break;
        case 2:                                                                 //  
                sprintf (str,"F%3d",parameter);
                s=getCode (str[0]); s=s|(1<<7); seg[3]=s;
                s=getCode (str[1]); seg[2]=s;
                s=getCode (str[2]); if (s == 0) {s = 63;} if (parameter < 1000) {s=s|(1<<7);}   seg[1]=s; // ,       "0",    0  99,9 ,     ;    100   ,    ,   
                s=getCode (str[3]); seg[0]=s;                                   // ...  "0",     3  4 .  - "0.0"
                break;        
        case 3:                                                                 //  
                sprintf (str,"H%3d",parameter);
                s=getCode (str[0]); s=s|(1<<7); seg[3]=s;
                s=getCode (str[1]); seg[2]=s;
                s=getCode (str[2]); if (s == 0) {s = 63;} s=s|(1<<7); seg[1]=s;
                s=getCode (str[3]); seg[0]=s;                                   // ..."0.0"
                break;        
        case 4:                                                                 //  (  ;  ""  1- .   4-)
                sprintf (str,"%04d",parameter); 
                if (g_Hblk == 3)                                                //      1- .  
                { if (g_Hled == 1) {g_Hled=0; seg[3]=getCode (' '); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);}    //  =1,    0     "if", ,  0,   1    "else" :  1,  () 1- .  ,  
                              else {g_Hled=1; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);} //      "main",  0,        "main",      n-(1) 
                }
                if (g_Hblk == 2) 
                { if (g_Hled == 1) {g_Hled=0; seg[3]=getCode (str[0]); seg[2]=getCode (' '); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);}
                              else {g_Hled=1; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);}
                }
                if (g_Hblk == 1) 
                { if (g_Hled == 1) {g_Hled=0; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (' '); seg[0]=getCode (str[3]);}
                              else {g_Hled=1; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);}
                }
                if (g_Hblk == 0) 
                { if (g_Hled == 1) {g_Hled=0; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (' ');}
                              else {g_Hled=1; seg[3]=getCode (str[0]); seg[2]=getCode (str[1]); seg[1]=getCode (str[2]); seg[0]=getCode (str[3]);}
                }
                break;        
        default: seg[0]=6; seg[1]=91; seg[2]=79; seg[3]=102;                    //     ,    "",  ,  "4321"
                break;
    }

}
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------   -   :)
void main ()
{
static char key=0,key_old=0; 
static unsigned short key_count=0,timer_count=0,mg_rash=0;                      //    ;
static unsigned long med_fuel=0,tm=0;                                           // ""    (tm)   "g_total_fuel"     1000 
static float Uadc=0;

init ();                                                                        //  -  
for (;;)                                                                        //   
{
    if (timer2comp == 1)                                                        //  ()    7200/20=360 
    {
    //----------------
                                                                                //  
            if (g_time_s < 360) {g_time_s++;}                                   //   1- .
              else {g_time_s=0; mg_rash = (unsigned long) (g_full_time * g_Hset ) / ((73728000 / 8) / 6 ) ; //  ,       . ;    .   ; 
                    med_fuel += g_full_time; g_full_time=0; }                   //   med_fuel   "g_full_time" (  .  .  -   1 .)  "med_fuel" -  50 ( ), . ,    "     1000"),   "g_full_time"         . . 

                                                                                //  
            if (med_fuel > 1000) { tm = med_fuel / 1000; g_total_fuel += tm; med_fuel -= tm*1000; // ..   g_total_fuel   ,      1000 ,         ,      "" 1000    ;  med_fuel > 1000, (, 500050),  
                mg_fuel = (unsigned long) (g_total_fuel * g_Hset ) / ((7372800 / 8)* 6); }        //  "tm"       1000 (500)     "g_total_fuel" (, 20),    - 520;  "med_fuel"     - (500050-500*1000=50)  - 50,      "" , . 
                 
                                                                                //   
            if (g_eesave_en == 1) { __EEPUT(EEADR2,g_total_fuel >> 24); __EEPUT(EEADR2+1,g_total_fuel >> 16); //  2 .    ,   EE   (, ..     EE  ,      0,  , ,      )  ,         ,   ""    g_total_fuel
                __EEPUT(EEADR2+2,g_total_fuel >> 8); __EEPUT(EEADR2+3,(char)g_total_fuel); g_eesave_en=0;}    //    24  ,         EEADR2,  .  g_total_fuel   16  ,  ..  "__EEPUT"  "char" ,      EEADR2+1     2-  ,   2-   4-   g_total_fuel,
                                                                                //     EEADR2+2 - 3- ,   EEADR2+3 - 4- ()  g_total_fuel;   ,   g_total_fuel     - "(unsigned char)",     (IAR)   ,  "unsigned char"     "char",      ;     ,      
    //----------------
    key_old = key;                                                              //   "old"  ,     -   : ,   ()     
    key = OutDisp ();                                                           //     ,     ,  - "OutDisp"
    if (key == 0) PORTD |= Bit(4); else PORTD &= ~Bit(4);                       //       -  ,     - 
        if (key != key_old)                                                     //     (     "" )
        {   
            if (key_count > 720)                                                //   2 .  
            {
                  //  if ((key_old & Bit(0)) != 0) {seg[0]=91;}                 //   0     /* 
                  //  if ((key_old & Bit(1)) != 0) {seg[0]=79;}                 //   1        ,
                  //  if ((key_old & Bit(2)) != 0) {seg[0]=79;}                 //   2           */
              if ((key_old & Bit(3)) != 0) {                                    //   3 (1- .) - (..      (  ),        ,     "key_old",   "key")
                                              if (g_Uset == 2)  {g_total_fuel = 0;}   //     2 .    ,   (g_Uset - . )
                                              if (g_Uset == 3)  {g_Uset = 4;}         //       -     -
                                             }  
              key_count=0;                                
            }   
            if (key_count > 20)                                                 //   2 .  
            {
                if ((key_old & Bit(0)) != 0) {if (g_Uset == 4)                  //   0 (4- .)     -
                                              { if (g_Hblk == 3) {g_Hblk = 2;}  //   (   ) 1- .  -   
                                           else if (g_Hblk == 2) {g_Hblk = 1;}
                                           else if (g_Hblk == 1) {g_Hblk = 0;}
                                           else if (g_Hblk == 0) {g_Hblk = 3; g_Uset = 3; __EEPUT(EEADR1,g_Hset >> 8);
                                                                                          __EEPUT(EEADR1+1,(char)g_Hset); } //   EE
                                              }
                                             }   
                if ((key_old & Bit(1)) != 0) {if (g_Uset == 4)                  //   1
                                              { if (g_Hblk == 3) {if (g_Hset >= 1000) { g_Hset = g_Hset - 1000;}}
                                                if (g_Hblk == 2) {if (g_Hset >= 100) { g_Hset = g_Hset - 100;}}
                                                if (g_Hblk == 1) {if (g_Hset >= 10) { g_Hset = g_Hset - 10;}}
                                                if (g_Hblk == 0) {if (g_Hset >= 1) { g_Hset = g_Hset - 1;}}
                                              }
                                             }   
                if ((key_old & Bit(2)) != 0) {if (g_Uset == 4)                  //   2
                                              { if (g_Hblk == 3) {if ((g_Hset + 1000) < 10000) {g_Hset = g_Hset + 1000;}}
                                                if (g_Hblk == 2) {if ((g_Hset + 100) < 10000) {g_Hset = g_Hset + 100;}}
                                                if (g_Hblk == 1) {if ((g_Hset + 10) < 10000) {g_Hset = g_Hset + 10;}}
                                                if (g_Hblk == 0) {if ((g_Hset + 1) < 10000) {g_Hset = g_Hset + 1;}}
                                              } 
                                             }   
                if ((key_old & Bit(3)) != 0) {                                  //   3
                                                if (g_Uset == 0)  g_Uset = 1;
                                          else  if (g_Uset == 1)  g_Uset = 3;   // U
                                          else  if (g_Uset == 2)  g_Uset = 1;   // H  
                                          else  if (g_Uset == 3)  g_Uset = 2;   // F
                                          else  if (g_Uset == 4)  g_Uset = 3;
                                             }   
            }   
        }
    if (key != 0 && key == key_old) {key_count++;} else {key_count=0;}
    //----------------
    if (timer_count > 180)                                                      // 0.5 . -     , ..      
    {                                                                           //     "",     
                                                                                //   1   .,          
        switch (g_Uset)                                                         //   ( - User)
        {   case 0:                                                             //   - "4321"
                    break;
            case 1: Uadc = (0.4016 * ADCrez) + 9.5684;                          //  
                    SetDataDisp (1,(unsigned short)Uadc);   
                    ADCSR |= Bit(ADSC);
                    break;  
            case 2: SetDataDisp (2,mg_fuel);                                    //  
                    break;
            case 3: SetDataDisp (3,mg_rash);                                    //                  
                    break;
            case 4: SetDataDisp (4,g_Hset);
                    break;
                    
            default:
                    break;              
        }
      timer_count=0;  
    }   
    timer_count++;
    //----------------
    timer2comp=0;
    }

}
}
